/* application-window.c generated by valac 0.34.6, the Vala compiler
 * generated from application-window.vala, do not modify */

/*
Peek Copyright (c) 2015-2017 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.

This file contains GPL 3 code taken from corebird, a Gtk+ linux Twitter client.
Copyright (C) 2013 Timm Bäder, https://github.com/baedert/corebird/
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "application.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>


#define PEEK_UI_TYPE_APPLICATION_WINDOW (peek_ui_application_window_get_type ())
#define PEEK_UI_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow))
#define PEEK_UI_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))
#define PEEK_UI_IS_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_IS_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_APPLICATION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))

typedef struct _PeekUiApplicationWindow PeekUiApplicationWindow;
typedef struct _PeekUiApplicationWindowClass PeekUiApplicationWindowClass;
typedef struct _PeekUiApplicationWindowPrivate PeekUiApplicationWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _PeekUiApplicationWindow {
	GtkApplicationWindow parent_instance;
	PeekUiApplicationWindowPrivate * priv;
};

struct _PeekUiApplicationWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _PeekUiApplicationWindowPrivate {
	PeekRecordingScreenRecorder* _recorder;
	gboolean _open_file_manager;
	gint _size_indicator_delay;
	gint _recording_start_delay;
	gchar* _default_file_name_format;
	gchar* _save_folder;
	GtkHeaderBar* headerbar;
	GtkWidget* recording_view;
	GtkButton* record_button;
	GtkButton* stop_button;
	GtkLabel* size_indicator;
	GtkLabel* delay_indicator;
	guint size_indicator_timeout;
	guint delay_indicator_timeout;
	gboolean is_recording;
	gboolean is_postprocessing;
	GFile* in_file;
	GFile* out_file;
	PeekRecordingRecordingArea active_recording_area;
	gchar* stop_button_label;
	GSettings* settings;
};

struct _Block4Data {
	int _ref_count_;
	PeekUiApplicationWindow* self;
	gint delay;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	gulong hide_handler;
};

struct _Block6Data {
	int _ref_count_;
	PeekUiApplicationWindow* self;
	GtkWidget* fallback_app_menu;
};


static gpointer peek_ui_application_window_parent_class = NULL;

GType peek_ui_application_window_get_type (void) G_GNUC_CONST;
#define PEEK_UI_APPLICATION_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowPrivate))
enum  {
	PEEK_UI_APPLICATION_WINDOW_DUMMY_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_RECORDER,
	PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER,
	PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY,
	PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY,
	PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT,
	PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER
};
#define PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE 300
PeekUiApplicationWindow* peek_ui_application_window_new (PeekApplication* application, PeekRecordingScreenRecorder* recorder);
PeekUiApplicationWindow* peek_ui_application_window_construct (GType object_type, PeekApplication* application, PeekRecordingScreenRecorder* recorder);
void peek_ui_application_window_set_recorder (PeekUiApplicationWindow* self, PeekRecordingScreenRecorder* value);
PeekRecordingScreenRecorder* peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self);
static void __lambda7_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_enter_recording_state (PeekUiApplicationWindow* self);
static void ___lambda7__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender, gpointer self);
static void __lambda8_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_file_chooser (PeekUiApplicationWindow* self);
static void ___lambda8__peek_recording_screen_recorder_recording_postprocess_started (PeekRecordingScreenRecorder* _sender, gpointer self);
static void __lambda11_ (PeekUiApplicationWindow* self, GFile* file);
static void peek_ui_application_window_try_save_file (PeekUiApplicationWindow* self);
static void ___lambda11__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender, GFile* file, gpointer self);
static void __lambda12_ (PeekUiApplicationWindow* self, gint status);
static void peek_ui_application_window_leave_recording_state (PeekUiApplicationWindow* self);
static void ___lambda12__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender, gint status, gpointer self);
static void peek_ui_application_window_toggle_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_toggle_recording_peek_application_toggle_recording (PeekApplication* _sender, gpointer self);
static void peek_ui_application_window_prepare_start_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_prepare_start_recording_peek_application_start_recording (PeekApplication* _sender, gpointer self);
static void peek_ui_application_window_prepare_stop_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording (PeekApplication* _sender, gpointer self);
static void peek_ui_application_window_load_geometry (PeekUiApplicationWindow* self);
void peek_ui_application_window_on_window_screen_changed (PeekUiApplicationWindow* self, GdkScreen* previous_screen);
static void __lambda15_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_size_indicator (PeekUiApplicationWindow* self);
static void ___lambda15__gtk_widget_show (GtkWidget* _sender, gpointer self);
static void peek_ui_application_window_set_close_button_position (PeekUiApplicationWindow* self);
static gboolean peek_ui_application_window_real_configure_event (GtkWidget* base, GdkEventConfigure* event);
static void peek_ui_application_window_get_recording_area (PeekUiApplicationWindow* self, PeekRecordingRecordingArea* result);
static gboolean peek_ui_application_window_real_delete_event (GtkWidget* base, GdkEventAny* event);
static void ___lambda18_ (PeekUiApplicationWindow* self, PeekUiApplicationWindow* file);
static void ____lambda18__peek_ui_application_window_recording_finished (PeekUiApplicationWindow* _sender, gpointer self);
static void peek_ui_application_window_save_geometry (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender, GdkScreen* previous_screen, gpointer self);
static gboolean peek_ui_application_window_on_window_draw (PeekUiApplicationWindow* self, GtkWidget* widget, cairo_t* ctx);
static void peek_ui_application_window_update_input_shape (PeekUiApplicationWindow* self);
static gboolean _peek_ui_application_window_on_window_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static gboolean peek_ui_application_window_on_recording_view_draw (PeekUiApplicationWindow* self, GtkWidget* widget, cairo_t* ctx);
static gboolean _peek_ui_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static void peek_ui_application_window_on_recording_view_size_allocate (PeekUiApplicationWindow* self, GtkAllocation* allocation);
static void _peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
static gint peek_ui_application_window_get_window_width (PeekUiApplicationWindow* self);
gint peek_ui_application_window_get_size_indicator_delay (PeekUiApplicationWindow* self);
static gboolean _____lambda17_ (PeekUiApplicationWindow* self);
static gboolean ______lambda17__gsource_func (gpointer self);
static void peek_ui_application_window_on_record_button_clicked (PeekUiApplicationWindow* self, GtkButton* source);
static void _peek_ui_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void peek_ui_application_window_on_stop_button_clicked (PeekUiApplicationWindow* self, GtkButton* source);
static void _peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
gint peek_ui_application_window_get_recording_start_delay (PeekUiApplicationWindow* self);
static gboolean ___lambda13_ (Block4Data* _data4_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda14_ (Block5Data* _data5_);
static void peek_ui_application_window_start_recording (PeekUiApplicationWindow* self);
static void ____lambda14__gtk_widget_hide (GtkWidget* _sender, gpointer self);
static gboolean ____lambda13__gsource_func (gpointer self);
static void peek_ui_application_window_freeze_window_size (PeekUiApplicationWindow* self);
static void peek_ui_application_window_unfreeze_window_size (PeekUiApplicationWindow* self);
static void ___lambda10_ (PeekUiApplicationWindow* self, GObject* obj, GAsyncResult* res);
static void ____lambda10__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static cairo_region_t* peek_ui_application_window_create_region_from_widget (PeekUiApplicationWindow* self, GtkWidget* widget);
static GtkWidget* peek_ui_application_window_get_fallback_app_menu (PeekUiApplicationWindow* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda16_ (Block6Data* _data6_, GtkWidget* child);
static void ___lambda16__gtk_callback (GtkWidget* widget, gpointer self);
const gchar* peek_ui_application_window_get_default_file_name_format (PeekUiApplicationWindow* self);
static gchar* peek_ui_application_window_load_preferred_save_folder (PeekUiApplicationWindow* self);
static void peek_ui_application_window_save_file (PeekUiApplicationWindow* self);
static void __lambda9_ (PeekUiApplicationWindow* self, GObject* obj, GAsyncResult* res);
static void peek_ui_application_window_handle_saved_file (PeekUiApplicationWindow* self, GFile* file);
static void ___lambda9__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void peek_ui_application_window_save_preferred_save_folder (PeekUiApplicationWindow* self, GFile* out_file);
gboolean peek_ui_application_window_get_open_file_manager (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_file_saved_notification (PeekUiApplicationWindow* self, GFile* file);
#define PEEK_APP_ID "com.uploadedlobster.peek"
const gchar* peek_ui_application_window_get_save_folder (PeekUiApplicationWindow* self);
void peek_ui_application_window_set_save_folder (PeekUiApplicationWindow* self, const gchar* value);
static void peek_ui_application_window_move_close_button_left (PeekUiApplicationWindow* self);
void peek_ui_application_window_set_open_file_manager (PeekUiApplicationWindow* self, gboolean value);
void peek_ui_application_window_set_size_indicator_delay (PeekUiApplicationWindow* self, gint value);
void peek_ui_application_window_set_recording_start_delay (PeekUiApplicationWindow* self, gint value);
void peek_ui_application_window_set_default_file_name_format (PeekUiApplicationWindow* self, const gchar* value);
static void peek_ui_application_window_finalize (GObject* obj);
static void _vala_peek_ui_application_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_peek_ui_application_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void __lambda7_ (PeekUiApplicationWindow* self) {
	peek_ui_application_window_enter_recording_state (self);
}


static void ___lambda7__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender, gpointer self) {
	__lambda7_ ((PeekUiApplicationWindow*) self);
}


static void __lambda8_ (PeekUiApplicationWindow* self) {
	self->priv->is_postprocessing = TRUE;
	peek_ui_application_window_show_file_chooser (self);
}


static void ___lambda8__peek_recording_screen_recorder_recording_postprocess_started (PeekRecordingScreenRecorder* _sender, gpointer self) {
	__lambda8_ ((PeekUiApplicationWindow*) self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda11_ (PeekUiApplicationWindow* self, GFile* file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->in_file);
	self->priv->in_file = _tmp1_;
	peek_ui_application_window_try_save_file (self);
}


static void ___lambda11__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender, GFile* file, gpointer self) {
	__lambda11_ ((PeekUiApplicationWindow*) self, file);
}


static void __lambda12_ (PeekUiApplicationWindow* self, gint status) {
	FILE* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	_tmp0_ = stderr;
	_tmp1_ = status;
	fprintf (_tmp0_, "Recording canceled with return code %i\n", _tmp1_);
	peek_ui_application_window_leave_recording_state (self);
}


static void ___lambda12__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender, gint status, gpointer self) {
	__lambda12_ ((PeekUiApplicationWindow*) self, status);
}


static void _peek_ui_application_window_toggle_recording_peek_application_toggle_recording (PeekApplication* _sender, gpointer self) {
	peek_ui_application_window_toggle_recording ((PeekUiApplicationWindow*) self);
}


static void _peek_ui_application_window_prepare_start_recording_peek_application_start_recording (PeekApplication* _sender, gpointer self) {
	peek_ui_application_window_prepare_start_recording ((PeekUiApplicationWindow*) self);
}


static void _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording (PeekApplication* _sender, gpointer self) {
	peek_ui_application_window_prepare_stop_recording ((PeekUiApplicationWindow*) self);
}


static void __lambda15_ (PeekUiApplicationWindow* self) {
	peek_ui_application_window_show_size_indicator (self);
}


static void ___lambda15__gtk_widget_show (GtkWidget* _sender, gpointer self) {
	__lambda15_ ((PeekUiApplicationWindow*) self);
}


PeekUiApplicationWindow* peek_ui_application_window_construct (GType object_type, PeekApplication* application, PeekRecordingScreenRecorder* recorder) {
	PeekUiApplicationWindow * self = NULL;
	PeekApplication* _tmp0_ = NULL;
	PeekRecordingScreenRecorder* _tmp1_ = NULL;
	PeekRecordingScreenRecorder* _tmp2_ = NULL;
	PeekRecordingScreenRecorder* _tmp3_ = NULL;
	PeekRecordingScreenRecorder* _tmp4_ = NULL;
	PeekRecordingScreenRecorder* _tmp5_ = NULL;
	PeekApplication* _tmp6_ = NULL;
	PeekApplication* _tmp7_ = NULL;
	PeekApplication* _tmp8_ = NULL;
	GSettings* _tmp9_ = NULL;
	GSettings* _tmp10_ = NULL;
	GSettings* _tmp11_ = NULL;
	GSettings* _tmp12_ = NULL;
	GSettings* _tmp13_ = NULL;
	GtkSettings* _tmp14_ = NULL;
	GSettings* _tmp15_ = NULL;
	PeekRecordingScreenRecorder* _tmp16_ = NULL;
	GSettings* _tmp17_ = NULL;
	PeekRecordingScreenRecorder* _tmp18_ = NULL;
	GSettings* _tmp19_ = NULL;
	PeekRecordingScreenRecorder* _tmp20_ = NULL;
	GSettings* _tmp21_ = NULL;
	PeekRecordingScreenRecorder* _tmp22_ = NULL;
	GSettings* _tmp23_ = NULL;
	GSettings* _tmp24_ = NULL;
	GtkButton* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	g_return_val_if_fail (recorder != NULL, NULL);
	_tmp0_ = application;
	self = (PeekUiApplicationWindow*) g_object_new (object_type, "application", _tmp0_, NULL);
	_tmp1_ = recorder;
	peek_ui_application_window_set_recorder (self, _tmp1_);
	_tmp2_ = self->priv->_recorder;
	g_signal_connect_object (_tmp2_, "recording-started", (GCallback) ___lambda7__peek_recording_screen_recorder_recording_started, self, 0);
	_tmp3_ = self->priv->_recorder;
	g_signal_connect_object (_tmp3_, "recording-postprocess-started", (GCallback) ___lambda8__peek_recording_screen_recorder_recording_postprocess_started, self, 0);
	_tmp4_ = self->priv->_recorder;
	g_signal_connect_object (_tmp4_, "recording-finished", (GCallback) ___lambda11__peek_recording_screen_recorder_recording_finished, self, 0);
	_tmp5_ = self->priv->_recorder;
	g_signal_connect_object (_tmp5_, "recording-aborted", (GCallback) ___lambda12__peek_recording_screen_recorder_recording_aborted, self, 0);
	_tmp6_ = application;
	g_signal_connect_object (_tmp6_, "toggle-recording", (GCallback) _peek_ui_application_window_toggle_recording_peek_application_toggle_recording, self, 0);
	_tmp7_ = application;
	g_signal_connect_object (_tmp7_, "start-recording", (GCallback) _peek_ui_application_window_prepare_start_recording_peek_application_start_recording, self, 0);
	_tmp8_ = application;
	g_signal_connect_object (_tmp8_, "stop-recording", (GCallback) _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording, self, 0);
	_tmp9_ = peek_application_get_app_settings ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp9_;
	_tmp10_ = self->priv->settings;
	g_settings_bind (_tmp10_, "interface-open-file-manager", (GObject*) self, "open_file_manager", G_SETTINGS_BIND_DEFAULT);
	_tmp11_ = self->priv->settings;
	g_settings_bind (_tmp11_, "interface-size-indicator-delay", (GObject*) self, "size_indicator_delay", G_SETTINGS_BIND_DEFAULT);
	_tmp12_ = self->priv->settings;
	g_settings_bind (_tmp12_, "interface-default-file-name-format", (GObject*) self, "default_file_name_format", G_SETTINGS_BIND_DEFAULT);
	_tmp13_ = self->priv->settings;
	_tmp14_ = gtk_widget_get_settings ((GtkWidget*) self);
	g_settings_bind (_tmp13_, "interface-prefer-dark-theme", (GObject*) _tmp14_, "gtk_application_prefer_dark_theme", G_SETTINGS_BIND_DEFAULT);
	_tmp15_ = self->priv->settings;
	_tmp16_ = self->priv->_recorder;
	g_settings_bind (_tmp15_, "recording-output-format", (GObject*) _tmp16_, "output_format", G_SETTINGS_BIND_DEFAULT);
	_tmp17_ = self->priv->settings;
	_tmp18_ = self->priv->_recorder;
	g_settings_bind (_tmp17_, "recording-framerate", (GObject*) _tmp18_, "framerate", G_SETTINGS_BIND_DEFAULT);
	_tmp19_ = self->priv->settings;
	_tmp20_ = self->priv->_recorder;
	g_settings_bind (_tmp19_, "recording-downsample", (GObject*) _tmp20_, "downsample", G_SETTINGS_BIND_DEFAULT);
	_tmp21_ = self->priv->settings;
	_tmp22_ = self->priv->_recorder;
	g_settings_bind (_tmp21_, "recording-capture-mouse", (GObject*) _tmp22_, "capture_mouse", G_SETTINGS_BIND_DEFAULT);
	_tmp23_ = self->priv->settings;
	g_settings_bind (_tmp23_, "recording-start-delay", (GObject*) self, "recording_start_delay", G_SETTINGS_BIND_DEFAULT);
	_tmp24_ = self->priv->settings;
	g_settings_bind (_tmp24_, "persist-save-folder", (GObject*) self, "save_folder", G_SETTINGS_BIND_DEFAULT);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	peek_ui_application_window_load_geometry (self);
	peek_ui_application_window_on_window_screen_changed (self, NULL);
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda15__gtk_widget_show, self, 0);
	_tmp25_ = self->priv->stop_button;
	_tmp26_ = gtk_button_get_label (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_strdup (_tmp27_);
	_g_free0 (self->priv->stop_button_label);
	self->priv->stop_button_label = _tmp28_;
	peek_ui_application_window_set_close_button_position (self);
	return self;
}


PeekUiApplicationWindow* peek_ui_application_window_new (PeekApplication* application, PeekRecordingScreenRecorder* recorder) {
	return peek_ui_application_window_construct (PEEK_UI_TYPE_APPLICATION_WINDOW, application, recorder);
}


static gboolean peek_ui_application_window_real_configure_event (GtkWidget* base, GdkEventConfigure* event) {
	PeekUiApplicationWindow * self;
	gboolean result = FALSE;
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkEventConfigure* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	self = (PeekUiApplicationWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_recorder;
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		PeekRecordingRecordingArea new_recording_area = {0};
		PeekRecordingRecordingArea _tmp3_ = {0};
		PeekRecordingRecordingArea _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		peek_ui_application_window_get_recording_area (self, &_tmp3_);
		new_recording_area = _tmp3_;
		_tmp4_ = self->priv->active_recording_area;
		_tmp5_ = peek_recording_recording_area_equals (&new_recording_area, &_tmp4_);
		if (!_tmp5_) {
			PeekRecordingScreenRecorder* _tmp6_ = NULL;
			_tmp6_ = self->priv->_recorder;
			peek_recording_screen_recorder_cancel (_tmp6_);
		}
		peek_recording_recording_area_destroy (&new_recording_area);
	}
	_tmp7_ = event;
	_tmp8_ = GTK_WIDGET_CLASS (peek_ui_application_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), _tmp7_);
	result = _tmp8_;
	return result;
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


static void ___lambda18_ (PeekUiApplicationWindow* self, PeekUiApplicationWindow* file) {
	g_return_if_fail (file != NULL);
	gtk_window_close ((GtkWindow*) self);
}


static void ____lambda18__peek_ui_application_window_recording_finished (PeekUiApplicationWindow* _sender, gpointer self) {
	___lambda18_ ((PeekUiApplicationWindow*) self, _sender);
}


static gboolean peek_ui_application_window_real_delete_event (GtkWidget* base, GdkEventAny* event) {
	PeekUiApplicationWindow * self;
	gboolean result = FALSE;
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	PeekRecordingScreenRecorder* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	guint _tmp17_ = 0U;
	guint _tmp19_ = 0U;
	self = (PeekUiApplicationWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_recorder;
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = bool_to_string (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->is_postprocessing;
	_tmp6_ = bool_to_string (_tmp5_);
	_tmp7_ = _tmp6_;
	g_debug ("application-window.vala:168: delete_event: recorder.is_recording=%s, w" \
"indow.is_postprocessing=%s", _tmp4_, _tmp7_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp4_);
	_tmp9_ = self->priv->_recorder;
	_tmp10_ = peek_recording_screen_recorder_get_is_recording (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		_tmp8_ = TRUE;
	} else {
		gboolean _tmp12_ = FALSE;
		_tmp12_ = self->priv->is_postprocessing;
		_tmp8_ = _tmp12_;
	}
	if (_tmp8_) {
		PeekRecordingScreenRecorder* _tmp13_ = NULL;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		g_signal_connect_object (self, "recording-finished", (GCallback) ____lambda18__peek_ui_application_window_recording_finished, self, 0);
		_tmp13_ = self->priv->_recorder;
		_tmp14_ = peek_recording_screen_recorder_get_is_recording (_tmp13_);
		_tmp15_ = _tmp14_;
		if (_tmp15_) {
			PeekRecordingScreenRecorder* _tmp16_ = NULL;
			_tmp16_ = self->priv->_recorder;
			peek_recording_screen_recorder_cancel (_tmp16_);
		}
		gtk_widget_hide ((GtkWidget*) self);
		result = TRUE;
		return result;
	}
	_tmp17_ = self->priv->size_indicator_timeout;
	if (_tmp17_ != ((guint) 0)) {
		guint _tmp18_ = 0U;
		_tmp18_ = self->priv->size_indicator_timeout;
		g_source_remove (_tmp18_);
	}
	_tmp19_ = self->priv->delay_indicator_timeout;
	if (_tmp19_ != ((guint) 0)) {
		guint _tmp20_ = 0U;
		_tmp20_ = self->priv->delay_indicator_timeout;
		g_source_remove (_tmp20_);
	}
	peek_ui_application_window_save_geometry (self);
	result = FALSE;
	return result;
}


void peek_ui_application_window_on_window_screen_changed (PeekUiApplicationWindow* self, GdkScreen* previous_screen) {
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkScreen* _tmp1_ = NULL;
	GdkVisual* visual = NULL;
	GdkScreen* _tmp2_ = NULL;
	GdkVisual* _tmp3_ = NULL;
	GdkVisual* _tmp4_ = NULL;
	GdkVisual* _tmp5_ = NULL;
	GdkVisual* _tmp10_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	visual = _tmp4_;
	_tmp5_ = visual;
	if (_tmp5_ == NULL) {
		FILE* _tmp6_ = NULL;
		GdkScreen* _tmp7_ = NULL;
		GdkVisual* _tmp8_ = NULL;
		GdkVisual* _tmp9_ = NULL;
		_tmp6_ = stderr;
		fprintf (_tmp6_, "Screen does not support alpha channels!");
		_tmp7_ = screen;
		_tmp8_ = gdk_screen_get_system_visual (_tmp7_);
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_g_object_unref0 (visual);
		visual = _tmp9_;
	}
	_tmp10_ = visual;
	gtk_widget_set_visual ((GtkWidget*) self, _tmp10_);
	_g_object_unref0 (visual);
	_g_object_unref0 (screen);
}


static void _peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender, GdkScreen* previous_screen, gpointer self) {
	peek_ui_application_window_on_window_screen_changed ((PeekUiApplicationWindow*) self, previous_screen);
}


static gboolean peek_ui_application_window_on_window_draw (PeekUiApplicationWindow* self, GtkWidget* widget, cairo_t* ctx) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	peek_ui_application_window_update_input_shape (self);
	result = FALSE;
	return result;
}


static gboolean _peek_ui_application_window_on_window_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = peek_ui_application_window_on_window_draw ((PeekUiApplicationWindow*) self, _sender, cr);
	return result;
}


static gboolean peek_ui_application_window_on_recording_view_draw (PeekUiApplicationWindow* self, GtkWidget* widget, cairo_t* ctx) {
	gboolean result = FALSE;
	cairo_t* _tmp0_ = NULL;
	cairo_t* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = ctx;
	cairo_set_operator (_tmp0_, CAIRO_OPERATOR_CLEAR);
	_tmp1_ = ctx;
	cairo_paint (_tmp1_);
	result = FALSE;
	return result;
}


static gboolean _peek_ui_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = peek_ui_application_window_on_recording_view_draw ((PeekUiApplicationWindow*) self, _sender, cr);
	return result;
}


static void peek_ui_application_window_on_recording_view_size_allocate (PeekUiApplicationWindow* self, GtkAllocation* allocation) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (allocation != NULL);
	peek_ui_application_window_show_size_indicator (self);
}


static void _peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
	peek_ui_application_window_on_recording_view_size_allocate ((PeekUiApplicationWindow*) self, allocation);
}


static gboolean _____lambda17_ (PeekUiApplicationWindow* self) {
	gboolean result = FALSE;
	GtkLabel* _tmp0_ = NULL;
	self->priv->size_indicator_timeout = (guint) 0;
	_tmp0_ = self->priv->size_indicator;
	gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.0);
	peek_ui_application_window_update_input_shape (self);
	result = FALSE;
	return result;
}


static gboolean ______lambda17__gsource_func (gpointer self) {
	gboolean result;
	result = _____lambda17_ ((PeekUiApplicationWindow*) self);
	return result;
}


static void peek_ui_application_window_show_size_indicator (PeekUiApplicationWindow* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_realized ((GtkWidget*) self);
	if (_tmp0_) {
		PeekRecordingRecordingArea area = {0};
		PeekRecordingRecordingArea _tmp1_ = {0};
		gint _tmp2_ = 0;
		gboolean _tmp7_ = FALSE;
		peek_ui_application_window_update_input_shape (self);
		peek_ui_application_window_get_recording_area (self, &_tmp1_);
		area = _tmp1_;
		_tmp2_ = peek_ui_application_window_get_window_width (self);
		if (_tmp2_ < PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
			GtkButton* _tmp3_ = NULL;
			GtkButton* _tmp4_ = NULL;
			_tmp3_ = self->priv->record_button;
			peek_gtk_helper_hide_button_label (_tmp3_);
			_tmp4_ = self->priv->stop_button;
			peek_gtk_helper_hide_button_label (_tmp4_);
		} else {
			GtkButton* _tmp5_ = NULL;
			GtkButton* _tmp6_ = NULL;
			_tmp5_ = self->priv->record_button;
			peek_gtk_helper_show_button_label (_tmp5_);
			_tmp6_ = self->priv->stop_button;
			peek_gtk_helper_show_button_label (_tmp6_);
		}
		_tmp7_ = self->priv->is_recording;
		if (!_tmp7_) {
			GString* size_label = NULL;
			GString* _tmp8_ = NULL;
			GString* _tmp9_ = NULL;
			PeekRecordingRecordingArea _tmp10_ = {0};
			gint _tmp11_ = 0;
			PeekRecordingRecordingArea _tmp12_ = {0};
			gint _tmp13_ = 0;
			GtkLabel* _tmp14_ = NULL;
			GString* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			GtkLabel* _tmp17_ = NULL;
			guint _tmp18_ = 0U;
			PeekRecordingScreenRecorder* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			_tmp8_ = g_string_new ("");
			size_label = _tmp8_;
			_tmp9_ = size_label;
			_tmp10_ = area;
			_tmp11_ = _tmp10_.width;
			_tmp12_ = area;
			_tmp13_ = _tmp12_.height;
			g_string_printf (_tmp9_, "%i x %i", _tmp11_, _tmp13_);
			_tmp14_ = self->priv->size_indicator;
			_tmp15_ = size_label;
			_tmp16_ = _tmp15_->str;
			gtk_label_set_text (_tmp14_, _tmp16_);
			_tmp17_ = self->priv->size_indicator;
			gtk_widget_show ((GtkWidget*) _tmp17_);
			_tmp18_ = self->priv->size_indicator_timeout;
			if (_tmp18_ != ((guint) 0)) {
				guint _tmp19_ = 0U;
				_tmp19_ = self->priv->size_indicator_timeout;
				g_source_remove (_tmp19_);
			}
			_tmp20_ = self->priv->_recorder;
			_tmp21_ = peek_recording_screen_recorder_get_is_recording (_tmp20_);
			_tmp22_ = _tmp21_;
			if (!_tmp22_) {
				GtkLabel* _tmp23_ = NULL;
				gint _tmp24_ = 0;
				guint _tmp25_ = 0U;
				_tmp23_ = self->priv->size_indicator;
				gtk_widget_set_opacity ((GtkWidget*) _tmp23_, 1.0);
				_tmp24_ = self->priv->_size_indicator_delay;
				_tmp25_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp24_, ______lambda17__gsource_func, g_object_ref (self), g_object_unref);
				self->priv->size_indicator_timeout = _tmp25_;
			}
			_g_string_free0 (size_label);
		}
		peek_recording_recording_area_destroy (&area);
	}
}


static void peek_ui_application_window_on_record_button_clicked (PeekUiApplicationWindow* self, GtkButton* source) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	peek_ui_application_window_prepare_start_recording (self);
}


static void _peek_ui_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	peek_ui_application_window_on_record_button_clicked ((PeekUiApplicationWindow*) self, _sender);
}


static void peek_ui_application_window_on_stop_button_clicked (PeekUiApplicationWindow* self, GtkButton* source) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	peek_ui_application_window_prepare_stop_recording (self);
}


static void _peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	peek_ui_application_window_on_stop_button_clicked ((PeekUiApplicationWindow*) self, _sender);
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		PeekUiApplicationWindow* self;
		self = _data4_->self;
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		PeekUiApplicationWindow* self;
		self = _data5_->_data4_->self;
		block4_data_unref (_data5_->_data4_);
		_data5_->_data4_ = NULL;
		g_slice_free (Block5Data, _data5_);
	}
}


static void ___lambda14_ (Block5Data* _data5_) {
	Block4Data* _data4_;
	PeekUiApplicationWindow* self;
	GtkLabel* _tmp0_ = NULL;
	gulong _tmp1_ = 0UL;
	_data4_ = _data5_->_data4_;
	self = _data4_->self;
	_tmp0_ = self->priv->delay_indicator;
	_tmp1_ = _data5_->hide_handler;
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
	peek_ui_application_window_start_recording (self);
}


static void ____lambda14__gtk_widget_hide (GtkWidget* _sender, gpointer self) {
	___lambda14_ (self);
}


static gboolean ___lambda13_ (Block4Data* _data4_) {
	PeekUiApplicationWindow* self;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	self = _data4_->self;
	_tmp0_ = _data4_->delay;
	_data4_->delay = _tmp0_ - 1;
	_tmp1_ = _data4_->delay;
	if (_tmp1_ == 0) {
		Block5Data* _data5_;
		GtkLabel* _tmp2_ = NULL;
		gulong _tmp3_ = 0UL;
		GtkLabel* _tmp4_ = NULL;
		_data5_ = g_slice_new0 (Block5Data);
		_data5_->_ref_count_ = 1;
		_data5_->_data4_ = block4_data_ref (_data4_);
		self->priv->delay_indicator_timeout = (guint) 0;
		_data5_->hide_handler = (gulong) 0;
		_tmp2_ = self->priv->delay_indicator;
		_tmp3_ = g_signal_connect_data ((GtkWidget*) _tmp2_, "hide", (GCallback) ____lambda14__gtk_widget_hide, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
		_data5_->hide_handler = _tmp3_;
		_tmp4_ = self->priv->delay_indicator;
		gtk_widget_hide ((GtkWidget*) _tmp4_);
		result = FALSE;
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return result;
	} else {
		GtkLabel* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		_tmp5_ = self->priv->delay_indicator;
		_tmp6_ = _data4_->delay;
		_tmp7_ = g_strdup_printf ("%i", _tmp6_);
		_tmp8_ = _tmp7_;
		gtk_label_set_text (_tmp5_, _tmp8_);
		_g_free0 (_tmp8_);
		result = TRUE;
		return result;
	}
}


static gboolean ____lambda13__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda13_ (self);
	return result;
}


static void peek_ui_application_window_prepare_start_recording (PeekUiApplicationWindow* self) {
	Block4Data* _data4_;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = self->priv->is_recording;
	if (_tmp0_) {
		block4_data_unref (_data4_);
		_data4_ = NULL;
		return;
	}
	peek_ui_application_window_enter_recording_state (self);
	_tmp1_ = self->priv->_recording_start_delay;
	_data4_->delay = _tmp1_;
	_tmp2_ = _data4_->delay;
	if (_tmp2_ > 0) {
		GtkLabel* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GtkLabel* _tmp7_ = NULL;
		GtkLabel* _tmp8_ = NULL;
		guint _tmp9_ = 0U;
		_tmp3_ = self->priv->delay_indicator;
		_tmp4_ = _data4_->delay;
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
		_tmp6_ = _tmp5_;
		gtk_label_set_text (_tmp3_, _tmp6_);
		_g_free0 (_tmp6_);
		_tmp7_ = self->priv->delay_indicator;
		gtk_widget_show ((GtkWidget*) _tmp7_);
		_tmp8_ = self->priv->size_indicator;
		gtk_widget_hide ((GtkWidget*) _tmp8_);
		_tmp9_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ____lambda13__gsource_func, block4_data_ref (_data4_), block4_data_unref);
		self->priv->delay_indicator_timeout = _tmp9_;
	} else {
		peek_ui_application_window_start_recording (self);
	}
	block4_data_unref (_data4_);
	_data4_ = NULL;
}


static void peek_ui_application_window_prepare_stop_recording (PeekUiApplicationWindow* self) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->is_recording;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->delay_indicator_timeout;
	if (_tmp1_ != ((guint) 0)) {
		guint _tmp2_ = 0U;
		_tmp2_ = self->priv->delay_indicator_timeout;
		g_source_remove (_tmp2_);
		self->priv->delay_indicator_timeout = (guint) 0;
		peek_ui_application_window_leave_recording_state (self);
	} else {
		PeekRecordingScreenRecorder* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		_tmp3_ = self->priv->_recorder;
		_tmp4_ = peek_recording_screen_recorder_get_is_recording (_tmp3_);
		_tmp5_ = _tmp4_;
		if (!_tmp5_) {
			return;
		} else {
			GtkButton* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			PeekRecordingScreenRecorder* _tmp10_ = NULL;
			_tmp6_ = self->priv->stop_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
			_tmp7_ = peek_ui_application_window_get_window_width (self);
			if (_tmp7_ >= PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
				GtkButton* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				_tmp8_ = self->priv->stop_button;
				_tmp9_ = _ ("Rendering…");
				gtk_button_set_label (_tmp8_, _tmp9_);
			}
			_tmp10_ = self->priv->_recorder;
			peek_recording_screen_recorder_stop (_tmp10_);
		}
	}
}


static void peek_ui_application_window_toggle_recording (PeekUiApplicationWindow* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->is_recording;
	if (_tmp0_) {
		peek_ui_application_window_prepare_stop_recording (self);
	} else {
		peek_ui_application_window_prepare_start_recording (self);
	}
}


static void peek_ui_application_window_start_recording (PeekUiApplicationWindow* self) {
	PeekRecordingRecordingArea area = {0};
	PeekRecordingRecordingArea _tmp0_ = {0};
	PeekRecordingRecordingArea _tmp1_ = {0};
	gint _tmp2_ = 0;
	PeekRecordingRecordingArea _tmp3_ = {0};
	gint _tmp4_ = 0;
	PeekRecordingRecordingArea _tmp5_ = {0};
	gint _tmp6_ = 0;
	PeekRecordingRecordingArea _tmp7_ = {0};
	gint _tmp8_ = 0;
	PeekRecordingRecordingArea _tmp9_ = {0};
	PeekRecordingRecordingArea _tmp10_ = {0};
	PeekRecordingScreenRecorder* _tmp11_ = NULL;
	PeekRecordingRecordingArea _tmp12_ = {0};
	gboolean _tmp13_ = FALSE;
	g_return_if_fail (self != NULL);
	peek_ui_application_window_get_recording_area (self, &_tmp0_);
	area = _tmp0_;
	_tmp1_ = area;
	_tmp2_ = _tmp1_.left;
	_tmp3_ = area;
	_tmp4_ = _tmp3_.top;
	_tmp5_ = area;
	_tmp6_ = _tmp5_.width;
	_tmp7_ = area;
	_tmp8_ = _tmp7_.height;
	g_debug ("application-window.vala:344: Recording area: %i, %i, %i, %i\n", _tmp2_, _tmp4_, _tmp6_, _tmp8_);
	_tmp9_ = area;
	peek_recording_recording_area_copy (&_tmp9_, &_tmp10_);
	peek_recording_recording_area_destroy (&self->priv->active_recording_area);
	self->priv->active_recording_area = _tmp10_;
	_tmp11_ = self->priv->_recorder;
	_tmp12_ = area;
	_tmp13_ = peek_recording_screen_recorder_record (_tmp11_, &_tmp12_);
	if (!_tmp13_) {
		peek_ui_application_window_leave_recording_state (self);
	}
	peek_recording_recording_area_destroy (&area);
}


static void peek_ui_application_window_enter_recording_state (PeekUiApplicationWindow* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->is_recording;
	if (!_tmp0_) {
		GtkLabel* _tmp1_ = NULL;
		GtkButton* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		GtkButton* _tmp6_ = NULL;
		GtkButton* _tmp7_ = NULL;
		self->priv->is_recording = TRUE;
		_tmp1_ = self->priv->size_indicator;
		gtk_widget_set_opacity ((GtkWidget*) _tmp1_, 0.0);
		_tmp2_ = self->priv->record_button;
		gtk_widget_hide ((GtkWidget*) _tmp2_);
		_tmp3_ = peek_ui_application_window_get_window_width (self);
		if (_tmp3_ >= PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
			GtkButton* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			_tmp4_ = self->priv->stop_button;
			_tmp5_ = self->priv->stop_button_label;
			gtk_button_set_label (_tmp4_, _tmp5_);
		}
		_tmp6_ = self->priv->stop_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
		_tmp7_ = self->priv->stop_button;
		gtk_widget_show ((GtkWidget*) _tmp7_);
		peek_ui_application_window_freeze_window_size (self);
		gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	}
}


static void ___lambda10_ (PeekUiApplicationWindow* self, GObject* obj, GAsyncResult* res) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (res != NULL);
	{
		gboolean delete_success = FALSE;
		GFile* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp0_ = self->priv->in_file;
		_tmp1_ = res;
		_tmp2_ = g_file_delete_finish (_tmp0_, _tmp1_, &_inner_error_);
		delete_success = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch21_g_error;
		}
		_tmp3_ = bool_to_string (delete_success);
		_tmp4_ = _tmp3_;
		g_debug ("application-window.vala:382: Temp file deleted: %s\n", _tmp4_);
		_g_free0 (_tmp4_);
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		fprintf (_tmp5_, "Temp file delete error: %s\n", _tmp7_);
		_g_error_free0 (e);
	}
	__finally21:
	{
		_g_object_unref0 (self->priv->in_file);
		self->priv->in_file = NULL;
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_signal_emit_by_name (self, "recording-finished");
}


static void ____lambda10__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	___lambda10_ ((PeekUiApplicationWindow*) self, source_object, res);
	g_object_unref (self);
}


static void peek_ui_application_window_leave_recording_state (PeekUiApplicationWindow* self) {
	GtkLabel* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_g_object_unref0 (self->priv->out_file);
	self->priv->out_file = NULL;
	_tmp0_ = self->priv->delay_indicator;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	self->priv->is_recording = FALSE;
	self->priv->is_postprocessing = FALSE;
	_tmp1_ = self->priv->stop_button;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->record_button;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	peek_ui_application_window_unfreeze_window_size (self);
	_tmp3_ = self->priv->in_file;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		_tmp4_ = self->priv->in_file;
		_tmp5_ = g_file_get_uri (_tmp4_);
		_tmp6_ = _tmp5_;
		g_debug ("application-window.vala:378: Deleting temp file %s\n", _tmp6_);
		_g_free0 (_tmp6_);
		_tmp7_ = self->priv->in_file;
		g_file_delete_async (_tmp7_, G_PRIORITY_DEFAULT, NULL, ____lambda10__gasync_ready_callback, g_object_ref (self));
	} else {
		g_signal_emit_by_name (self, "recording-finished");
	}
}


static void peek_ui_application_window_update_input_shape (PeekUiApplicationWindow* self) {
	cairo_region_t* window_region = NULL;
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	cairo_region_t* _tmp2_ = NULL;
	cairo_region_t* recording_view_region = NULL;
	GtkWidget* _tmp3_ = NULL;
	cairo_region_t* _tmp4_ = NULL;
	cairo_region_t* _tmp5_ = NULL;
	cairo_region_t* _tmp6_ = NULL;
	GtkWidget* fallback_app_menu = NULL;
	GtkWidget* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GtkWidget* _tmp9_ = NULL;
	cairo_region_t* _tmp17_ = NULL;
	GdkScreen* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->recording_view;
	_tmp1_ = gtk_widget_get_toplevel (_tmp0_);
	_tmp2_ = peek_ui_application_window_create_region_from_widget (self, _tmp1_);
	window_region = _tmp2_;
	_tmp3_ = self->priv->recording_view;
	_tmp4_ = peek_ui_application_window_create_region_from_widget (self, _tmp3_);
	recording_view_region = _tmp4_;
	_tmp5_ = window_region;
	_tmp6_ = recording_view_region;
	cairo_region_subtract (_tmp5_, _tmp6_);
	_tmp7_ = peek_ui_application_window_get_fallback_app_menu (self);
	fallback_app_menu = _tmp7_;
	_tmp9_ = fallback_app_menu;
	if (_tmp9_ != NULL) {
		GtkWidget* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		_tmp10_ = fallback_app_menu;
		_tmp11_ = gtk_widget_get_visible (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp8_ = _tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		cairo_region_t* app_menu_region = NULL;
		GtkWidget* _tmp13_ = NULL;
		cairo_region_t* _tmp14_ = NULL;
		cairo_region_t* _tmp15_ = NULL;
		cairo_region_t* _tmp16_ = NULL;
		_tmp13_ = fallback_app_menu;
		_tmp14_ = peek_ui_application_window_create_region_from_widget (self, _tmp13_);
		app_menu_region = _tmp14_;
		_tmp15_ = window_region;
		_tmp16_ = app_menu_region;
		cairo_region_union (_tmp15_, _tmp16_);
		_cairo_region_destroy0 (app_menu_region);
	}
	_tmp17_ = window_region;
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp17_);
	_tmp18_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp19_ = gdk_screen_is_composited (_tmp18_);
	if (!_tmp19_) {
		gboolean _tmp20_ = FALSE;
		guint _tmp21_ = 0U;
		_tmp21_ = self->priv->delay_indicator_timeout;
		if (_tmp21_ == ((guint) 0)) {
			guint _tmp22_ = 0U;
			_tmp22_ = self->priv->size_indicator_timeout;
			_tmp20_ = _tmp22_ == ((guint) 0);
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			cairo_region_t* _tmp23_ = NULL;
			_tmp23_ = window_region;
			gtk_widget_shape_combine_region ((GtkWidget*) self, _tmp23_);
		} else {
			gtk_widget_shape_combine_region ((GtkWidget*) self, NULL);
		}
	}
	_g_object_unref0 (fallback_app_menu);
	_cairo_region_destroy0 (recording_view_region);
	_cairo_region_destroy0 (window_region);
}


static Block6Data* block6_data_ref (Block6Data* _data6_) {
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		PeekUiApplicationWindow* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->fallback_app_menu);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static void __lambda16_ (Block6Data* _data6_, GtkWidget* child) {
	PeekUiApplicationWindow* self;
	GtkWidget* _tmp0_ = NULL;
	self = _data6_->self;
	g_return_if_fail (child != NULL);
	_tmp0_ = child;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_popover_get_type ())) {
		GtkWidget* _tmp1_ = NULL;
		GtkWidget* _tmp2_ = NULL;
		_tmp1_ = child;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (_data6_->fallback_app_menu);
		_data6_->fallback_app_menu = _tmp2_;
	}
}


static void ___lambda16__gtk_callback (GtkWidget* widget, gpointer self) {
	__lambda16_ (self, widget);
}


static GtkWidget* peek_ui_application_window_get_fallback_app_menu (PeekUiApplicationWindow* self) {
	GtkWidget* result = NULL;
	Block6Data* _data6_;
	GtkApplication* _tmp0_ = NULL;
	GtkApplication* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_ = NULL;
	GtkWidget* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_application_prefers_app_menu (_tmp1_);
	if (_tmp2_) {
		result = NULL;
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return result;
	}
	_data6_->fallback_app_menu = NULL;
	gtk_container_forall ((GtkContainer*) self, ___lambda16__gtk_callback, _data6_);
	_tmp3_ = _data6_->fallback_app_menu;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	result = _tmp4_;
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}


static void peek_ui_application_window_freeze_window_size (PeekUiApplicationWindow* self) {
	gint width = 0;
	gint _tmp0_ = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	g_debug ("application-window.vala:440: freeze_window_size w: %d, h: %d", width, height);
	gtk_widget_set_size_request ((GtkWidget*) self, width, height);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
}


static void peek_ui_application_window_unfreeze_window_size (PeekUiApplicationWindow* self) {
	gint width = 0;
	gint _tmp0_ = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	g_debug ("application-window.vala:448: unfreeze_window_size w: %d, h: %d", width, height);
	gtk_widget_set_size_request ((GtkWidget*) self, 0, 0);
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
}


static cairo_region_t* peek_ui_application_window_create_region_from_widget (PeekUiApplicationWindow* self, GtkWidget* widget) {
	cairo_region_t* result = NULL;
	cairo_rectangle_int_t rectangle = {0};
	GtkWidget* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GtkWidget* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	cairo_rectangle_int_t _tmp4_ = {0};
	GtkWidget* _tmp5_ = NULL;
	GtkWidget* _tmp6_ = NULL;
	GtkWidget* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	cairo_region_t* region = NULL;
	cairo_rectangle_int_t _tmp10_ = {0};
	cairo_region_t* _tmp11_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (widget != NULL, NULL);
	_tmp0_ = widget;
	_tmp1_ = gtk_widget_get_allocated_width (_tmp0_);
	_tmp2_ = widget;
	_tmp3_ = gtk_widget_get_allocated_height (_tmp2_);
	memset (&_tmp4_, 0, sizeof (cairo_rectangle_int_t));
	_tmp4_.width = _tmp1_;
	_tmp4_.height = _tmp3_;
	rectangle = _tmp4_;
	_tmp5_ = widget;
	_tmp6_ = widget;
	_tmp7_ = gtk_widget_get_toplevel (_tmp6_);
	gtk_widget_translate_coordinates (_tmp5_, _tmp7_, 0, 0, &_tmp8_, &_tmp9_);
	rectangle.x = _tmp8_;
	rectangle.y = _tmp9_;
	_tmp10_ = rectangle;
	_tmp11_ = cairo_region_create_rectangle (&_tmp10_);
	region = _tmp11_;
	result = region;
	return result;
}


static void peek_ui_application_window_get_recording_area (PeekUiApplicationWindow* self, PeekRecordingRecordingArea* result) {
	GtkWidget* _tmp0_ = NULL;
	PeekRecordingRecordingArea _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->recording_view;
	peek_recording_recording_area_create_for_widget (_tmp0_, &_tmp1_);
	*result = _tmp1_;
	return;
}


static void peek_ui_application_window_show_file_chooser (PeekUiApplicationWindow* self) {
	GtkFileChooserDialog* chooser = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GtkFileChooserDialog* _tmp2_ = NULL;
	GtkWidget* ok_button = NULL;
	GtkFileChooserDialog* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GtkWidget* _tmp5_ = NULL;
	GtkWidget* _tmp6_ = NULL;
	GtkWidget* _tmp7_ = NULL;
	GtkStyleContext* _tmp8_ = NULL;
	GtkFileChooserDialog* _tmp9_ = NULL;
	gchar* extension = NULL;
	PeekRecordingScreenRecorder* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* filename = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp20_ = NULL;
	GtkFileFilter* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	GtkFileChooserDialog* _tmp25_ = NULL;
	GtkFileFilter* _tmp26_ = NULL;
	gchar* folder = NULL;
	gchar* _tmp27_ = NULL;
	GtkFileChooserDialog* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp30_ = NULL;
	gchar* default_name = NULL;
	GDateTime* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	gchar* _tmp33_ = NULL;
	GtkFileChooserDialog* _tmp34_ = NULL;
	const gchar* _tmp35_ = NULL;
	GtkFileChooserDialog* _tmp36_ = NULL;
	gint _tmp37_ = 0;
	GtkFileChooserDialog* _tmp44_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = _ ("Save animation");
	_tmp1_ = _ ("_Cancel");
	_tmp2_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_tmp0_, (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SAVE, _tmp1_, GTK_RESPONSE_CANCEL, NULL);
	g_object_ref_sink (_tmp2_);
	chooser = _tmp2_;
	_tmp3_ = chooser;
	_tmp4_ = _ ("_Save");
	_tmp5_ = gtk_dialog_add_button ((GtkDialog*) _tmp3_, _tmp4_, (gint) GTK_RESPONSE_ACCEPT);
	_tmp6_ = _g_object_ref0 (_tmp5_);
	ok_button = _tmp6_;
	_tmp7_ = ok_button;
	_tmp8_ = gtk_widget_get_style_context (_tmp7_);
	gtk_style_context_add_class (_tmp8_, "suggested-action");
	_tmp9_ = chooser;
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp9_, TRUE);
	_tmp10_ = self->priv->_recorder;
	_tmp11_ = peek_recording_screen_recorder_get_output_format (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = peek_utils_get_file_extension_for_format (_tmp12_);
	extension = _tmp13_;
	_tmp14_ = self->priv->_default_file_name_format;
	_tmp15_ = g_strconcat (_tmp14_, ".", NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = extension;
	_tmp18_ = g_strconcat (_tmp16_, _tmp17_, NULL);
	_tmp19_ = _tmp18_;
	_g_free0 (_tmp16_);
	filename = _tmp19_;
	_tmp20_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp20_);
	filter = _tmp20_;
	_tmp21_ = filter;
	_tmp22_ = extension;
	_tmp23_ = g_strconcat ("*.", _tmp22_, NULL);
	_tmp24_ = _tmp23_;
	gtk_file_filter_add_pattern (_tmp21_, _tmp24_);
	_g_free0 (_tmp24_);
	_tmp25_ = chooser;
	_tmp26_ = filter;
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp25_, _tmp26_);
	_tmp27_ = peek_ui_application_window_load_preferred_save_folder (self);
	folder = _tmp27_;
	_tmp28_ = chooser;
	_tmp29_ = folder;
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp28_, _tmp29_);
	_tmp30_ = g_date_time_new_now_local ();
	now = _tmp30_;
	_tmp31_ = now;
	_tmp32_ = filename;
	_tmp33_ = g_date_time_format (_tmp31_, _tmp32_);
	default_name = _tmp33_;
	_tmp34_ = chooser;
	_tmp35_ = default_name;
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp34_, _tmp35_);
	g_debug ("application-window.vala:504: Showing file chooser");
	_tmp36_ = chooser;
	_tmp37_ = gtk_dialog_run ((GtkDialog*) _tmp36_);
	if (_tmp37_ == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserDialog* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_ = NULL;
		GtkFileChooserDialog* _tmp41_ = NULL;
		GFile* _tmp42_ = NULL;
		_tmp38_ = chooser;
		_tmp39_ = gtk_file_chooser_get_uri ((GtkFileChooser*) _tmp38_);
		_tmp40_ = _tmp39_;
		g_debug ("application-window.vala:506: Selected file %s", _tmp40_);
		_g_free0 (_tmp40_);
		_tmp41_ = chooser;
		_tmp42_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp41_);
		_g_object_unref0 (self->priv->out_file);
		self->priv->out_file = _tmp42_;
		peek_ui_application_window_try_save_file (self);
	} else {
		PeekRecordingScreenRecorder* _tmp43_ = NULL;
		_tmp43_ = self->priv->_recorder;
		peek_recording_screen_recorder_cancel (_tmp43_);
		peek_ui_application_window_leave_recording_state (self);
	}
	_tmp44_ = chooser;
	g_signal_emit_by_name ((GtkDialog*) _tmp44_, "close");
	_g_free0 (default_name);
	_g_date_time_unref0 (now);
	_g_free0 (folder);
	_g_object_unref0 (filter);
	_g_free0 (filename);
	_g_free0 (extension);
	_g_object_unref0 (ok_button);
	_g_object_unref0 (chooser);
}


static void peek_ui_application_window_try_save_file (PeekUiApplicationWindow* self) {
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->in_file;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GFile* _tmp2_ = NULL;
		_tmp2_ = self->priv->out_file;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	peek_ui_application_window_save_file (self);
}


static void __lambda9_ (PeekUiApplicationWindow* self, GObject* obj, GAsyncResult* res) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (res != NULL);
	{
		gboolean copy_success = FALSE;
		GFile* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		_tmp0_ = self->priv->in_file;
		_tmp1_ = res;
		_tmp2_ = g_file_copy_finish (_tmp0_, _tmp1_, &_inner_error_);
		copy_success = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch22_g_error;
		}
		_tmp3_ = bool_to_string (copy_success);
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->out_file;
		_tmp6_ = g_file_get_uri (_tmp5_);
		_tmp7_ = _tmp6_;
		g_debug ("application-window.vala:533: File saved %s: %s", _tmp4_, _tmp7_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp4_);
		if (copy_success) {
			GFile* _tmp8_ = NULL;
			_tmp8_ = self->priv->out_file;
			peek_ui_application_window_handle_saved_file (self, _tmp8_);
		} else {
			if (!copy_success) {
				FILE* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				_tmp9_ = stderr;
				_tmp10_ = self->priv->out_file;
				_tmp11_ = g_file_get_uri (_tmp10_);
				_tmp12_ = _tmp11_;
				fprintf (_tmp9_, "Saving file %s failed.\n", _tmp12_);
				_g_free0 (_tmp12_);
			}
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
		FILE* _tmp13_ = NULL;
		GError* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = stderr;
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		fprintf (_tmp13_, "File save error: %s\n", _tmp15_);
		_g_error_free0 (e);
	}
	__finally22:
	{
		peek_ui_application_window_leave_recording_state (self);
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda9__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda9_ ((PeekUiApplicationWindow*) self, source_object, res);
	g_object_unref (self);
}


static void peek_ui_application_window_save_file (PeekUiApplicationWindow* self) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->in_file;
	_tmp1_ = self->priv->out_file;
	g_file_copy_async (_tmp0_, _tmp1_, G_FILE_COPY_OVERWRITE, G_PRIORITY_DEFAULT, NULL, NULL, NULL, ___lambda9__gasync_ready_callback, g_object_ref (self));
}


static void peek_ui_application_window_handle_saved_file (PeekUiApplicationWindow* self, GFile* file) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	peek_ui_application_window_save_preferred_save_folder (self, _tmp0_);
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean _tmp4_ = FALSE;
		_tmp4_ = self->priv->_open_file_manager;
		_tmp1_ = _tmp4_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GFile* _tmp5_ = NULL;
		_tmp5_ = file;
		peek_desktop_integration_launch_file_manager (_tmp5_);
	} else {
		GFile* _tmp6_ = NULL;
		_tmp6_ = file;
		peek_ui_application_window_show_file_saved_notification (self, _tmp6_);
	}
}


static void peek_ui_application_window_show_file_saved_notification (PeekUiApplicationWindow* self, GFile* file) {
	GString* message = NULL;
	GString* _tmp0_ = NULL;
	GString* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GNotification* notification = NULL;
	GString* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	GNotification* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	GVariant* parameter = NULL;
	GFile* _tmp29_ = NULL;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	GVariant* _tmp32_ = NULL;
	GVariant* _tmp33_ = NULL;
	gboolean _tmp34_ = FALSE;
	GString* _tmp45_ = NULL;
	const gchar* _tmp46_ = NULL;
	GtkApplication* _tmp47_ = NULL;
	GtkApplication* _tmp48_ = NULL;
	GNotification* _tmp49_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_string_new ("");
	message = _tmp0_;
	_tmp1_ = message;
	_tmp2_ = _ ("Animation saved as “%s”");
	_tmp3_ = file;
	_tmp4_ = g_file_get_basename (_tmp3_);
	_tmp5_ = _tmp4_;
	g_string_printf (_tmp1_, _tmp2_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = message;
	_tmp7_ = _tmp6_->str;
	_tmp8_ = g_notification_new (_tmp7_);
	notification = _tmp8_;
	_tmp9_ = peek_desktop_integration_is_cinnamon ();
	if (!_tmp9_) {
		GNotification* _tmp10_ = NULL;
		GThemedIcon* _tmp11_ = NULL;
		GThemedIcon* _tmp12_ = NULL;
		_tmp10_ = notification;
		_tmp11_ = (GThemedIcon*) g_themed_icon_new (PEEK_APP_ID);
		_tmp12_ = _tmp11_;
		g_notification_set_icon (_tmp10_, (GIcon*) _tmp12_);
		_g_object_unref0 (_tmp12_);
	} else {
		GtkIconTheme* icon_theme = NULL;
		GtkIconTheme* _tmp13_ = NULL;
		GtkIconTheme* _tmp14_ = NULL;
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp15_ = NULL;
		GtkIconInfo* _tmp16_ = NULL;
		gchar* icon_path = NULL;
		GtkIconInfo* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		_tmp13_ = gtk_icon_theme_get_default ();
		_tmp14_ = _g_object_ref0 (_tmp13_);
		icon_theme = _tmp14_;
		_tmp15_ = icon_theme;
		_tmp16_ = gtk_icon_theme_lookup_icon (_tmp15_, PEEK_APP_ID, 48, 0);
		icon_info = _tmp16_;
		_tmp17_ = icon_info;
		_tmp18_ = gtk_icon_info_get_filename (_tmp17_);
		_tmp19_ = g_strdup (_tmp18_);
		icon_path = _tmp19_;
		_tmp20_ = icon_path;
		g_debug ("application-window.vala:578: Using notification icon: %s", _tmp20_);
		_tmp21_ = icon_path;
		if (_tmp21_ != NULL) {
			GFileIcon* icon = NULL;
			const gchar* _tmp22_ = NULL;
			GFile* _tmp23_ = NULL;
			GFile* _tmp24_ = NULL;
			GFileIcon* _tmp25_ = NULL;
			GFileIcon* _tmp26_ = NULL;
			GNotification* _tmp27_ = NULL;
			GFileIcon* _tmp28_ = NULL;
			_tmp22_ = icon_path;
			_tmp23_ = g_file_new_for_path (_tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = (GFileIcon*) g_file_icon_new (_tmp24_);
			_tmp26_ = _tmp25_;
			_g_object_unref0 (_tmp24_);
			icon = _tmp26_;
			_tmp27_ = notification;
			_tmp28_ = icon;
			g_notification_set_icon (_tmp27_, (GIcon*) _tmp28_);
			_g_object_unref0 (icon);
		}
		_g_free0 (icon_path);
		_gtk_icon_info_free0 (icon_info);
		_g_object_unref0 (icon_theme);
	}
	_tmp29_ = file;
	_tmp30_ = g_file_get_uri (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_variant_new_string (_tmp31_);
	g_variant_ref_sink (_tmp32_);
	_tmp33_ = _tmp32_;
	_g_free0 (_tmp31_);
	parameter = _tmp33_;
	_tmp34_ = peek_desktop_integration_is_unity ();
	if (!_tmp34_) {
		GNotification* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		GNotification* _tmp37_ = NULL;
		const gchar* _tmp38_ = NULL;
		GVariant* _tmp39_ = NULL;
		gboolean _tmp40_ = FALSE;
		gboolean _tmp41_ = FALSE;
		_tmp35_ = notification;
		_tmp36_ = _ ("Click here to show the saved file in your file manager.");
		g_notification_set_body (_tmp35_, _tmp36_);
		_tmp37_ = notification;
		_tmp38_ = _ ("Show in file manager");
		_tmp39_ = parameter;
		g_notification_add_button_with_target_value (_tmp37_, _tmp38_, "app.show-file", _tmp39_);
		_tmp41_ = peek_desktop_integration_is_plasma ();
		if (!_tmp41_) {
			gboolean _tmp42_ = FALSE;
			_tmp42_ = peek_desktop_integration_is_xfce ();
			_tmp40_ = !_tmp42_;
		} else {
			_tmp40_ = FALSE;
		}
		if (_tmp40_) {
			GNotification* _tmp43_ = NULL;
			GVariant* _tmp44_ = NULL;
			_tmp43_ = notification;
			_tmp44_ = parameter;
			g_notification_set_default_action_and_target_value (_tmp43_, "app.show-file", _tmp44_);
		}
	}
	_tmp45_ = message;
	_tmp46_ = _tmp45_->str;
	g_debug ("application-window.vala:607: Showing desktop notification: %s", _tmp46_);
	_tmp47_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp48_ = _tmp47_;
	_tmp49_ = notification;
	g_application_send_notification ((GApplication*) _tmp48_, "peek-file-saved", _tmp49_);
	_g_variant_unref0 (parameter);
	_g_object_unref0 (notification);
	_g_string_free0 (message);
}


static gchar* peek_ui_application_window_load_preferred_save_folder (PeekUiApplicationWindow* self) {
	gchar* result = NULL;
	gchar* folder = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_save_folder;
	_tmp1_ = g_strdup (_tmp0_);
	folder = _tmp1_;
	_tmp4_ = folder;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_ = NULL;
		_tmp5_ = folder;
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp6_ = folder;
		_tmp7_ = g_file_test (_tmp6_, G_FILE_TEST_IS_DIR);
		_tmp2_ = !_tmp7_;
	}
	if (_tmp2_) {
		gchar* _tmp8_ = NULL;
		_tmp8_ = peek_desktop_integration_get_video_folder ();
		_g_free0 (folder);
		folder = _tmp8_;
	}
	result = folder;
	return result;
}


static void peek_ui_application_window_save_preferred_save_folder (PeekUiApplicationWindow* self, GFile* out_file) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (out_file != NULL);
	_tmp0_ = out_file;
	_tmp1_ = g_file_has_uri_scheme (_tmp0_, "file");
	if (_tmp1_) {
		GFile* parent = NULL;
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		gchar* new_folder = NULL;
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* default_folder = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		_tmp2_ = out_file;
		_tmp3_ = g_file_get_parent (_tmp2_);
		parent = _tmp3_;
		_tmp4_ = parent;
		_tmp5_ = g_file_get_path (_tmp4_);
		new_folder = _tmp5_;
		_tmp6_ = peek_desktop_integration_get_video_folder ();
		default_folder = _tmp6_;
		_tmp7_ = new_folder;
		_tmp8_ = default_folder;
		if (g_strcmp0 (_tmp7_, _tmp8_) != 0) {
			const gchar* _tmp9_ = NULL;
			_tmp9_ = new_folder;
			peek_ui_application_window_set_save_folder (self, _tmp9_);
		}
		_g_free0 (default_folder);
		_g_free0 (new_folder);
		_g_object_unref0 (parent);
	}
}


static void peek_ui_application_window_load_geometry (PeekUiApplicationWindow* self) {
	GVariant* geom = NULL;
	GSettings* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	GVariant* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	gint32 _tmp5_ = 0;
	GVariant* _tmp6_ = NULL;
	GVariant* _tmp7_ = NULL;
	GVariant* _tmp8_ = NULL;
	gint32 _tmp9_ = 0;
	GVariant* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	GVariant* _tmp12_ = NULL;
	gint32 _tmp13_ = 0;
	GVariant* _tmp14_ = NULL;
	GVariant* _tmp15_ = NULL;
	GVariant* _tmp16_ = NULL;
	gint32 _tmp17_ = 0;
	gboolean _tmp18_ = FALSE;
	gint _tmp19_ = 0;
	gboolean _tmp21_ = FALSE;
	gint _tmp22_ = 0;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "persist-window-geometry");
	geom = _tmp1_;
	x = 0;
	y = 0;
	w = 0;
	h = 0;
	_tmp2_ = geom;
	_tmp3_ = g_variant_get_child_value (_tmp2_, (gsize) 0);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_variant_get_int32 (_tmp4_);
	x = (gint) _tmp5_;
	_g_variant_unref0 (_tmp4_);
	_tmp6_ = geom;
	_tmp7_ = g_variant_get_child_value (_tmp6_, (gsize) 1);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_variant_get_int32 (_tmp8_);
	y = (gint) _tmp9_;
	_g_variant_unref0 (_tmp8_);
	_tmp10_ = geom;
	_tmp11_ = g_variant_get_child_value (_tmp10_, (gsize) 2);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_variant_get_int32 (_tmp12_);
	w = (gint) _tmp13_;
	_g_variant_unref0 (_tmp12_);
	_tmp14_ = geom;
	_tmp15_ = g_variant_get_child_value (_tmp14_, (gsize) 3);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_variant_get_int32 (_tmp16_);
	h = (gint) _tmp17_;
	_g_variant_unref0 (_tmp16_);
	_tmp19_ = w;
	if (_tmp19_ == 0) {
		_tmp18_ = TRUE;
	} else {
		gint _tmp20_ = 0;
		_tmp20_ = h;
		_tmp18_ = _tmp20_ == 0;
	}
	if (_tmp18_) {
		_g_variant_unref0 (geom);
		return;
	}
	_tmp22_ = x;
	if (_tmp22_ >= 0) {
		gint _tmp23_ = 0;
		_tmp23_ = y;
		_tmp21_ = _tmp23_ >= 0;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		_tmp24_ = x;
		_tmp25_ = y;
		gtk_window_move ((GtkWindow*) self, _tmp24_, _tmp25_);
	}
	_tmp26_ = w;
	_tmp27_ = h;
	gtk_window_resize ((GtkWindow*) self, _tmp26_, _tmp27_);
	_g_variant_unref0 (geom);
}


static void peek_ui_application_window_save_geometry (PeekUiApplicationWindow* self) {
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp0_ = NULL;
	GVariantBuilder* _tmp1_ = NULL;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GVariant* _tmp7_ = NULL;
	GVariant* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	GVariant* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	GVariant* _tmp13_ = NULL;
	GVariant* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	GVariant* _tmp16_ = NULL;
	GVariant* _tmp17_ = NULL;
	GSettings* _tmp18_ = NULL;
	GVariant* _tmp19_ = NULL;
	GVariant* _tmp20_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = G_VARIANT_TYPE_TUPLE;
	_tmp1_ = g_variant_builder_new (_tmp0_);
	builder = _tmp1_;
	x = 0;
	y = 0;
	w = 0;
	h = 0;
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
	x = _tmp2_;
	y = _tmp3_;
	gtk_window_get_size ((GtkWindow*) self, &_tmp4_, &_tmp5_);
	w = _tmp4_;
	h = _tmp5_;
	_tmp6_ = x;
	_tmp7_ = g_variant_new_int32 ((gint32) _tmp6_);
	g_variant_ref_sink (_tmp7_);
	_tmp8_ = _tmp7_;
	g_variant_builder_add_value (builder, _tmp8_);
	_g_variant_unref0 (_tmp8_);
	_tmp9_ = y;
	_tmp10_ = g_variant_new_int32 ((gint32) _tmp9_);
	g_variant_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	g_variant_builder_add_value (builder, _tmp11_);
	_g_variant_unref0 (_tmp11_);
	_tmp12_ = w;
	_tmp13_ = g_variant_new_int32 ((gint32) _tmp12_);
	g_variant_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	g_variant_builder_add_value (builder, _tmp14_);
	_g_variant_unref0 (_tmp14_);
	_tmp15_ = h;
	_tmp16_ = g_variant_new_int32 ((gint32) _tmp15_);
	g_variant_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	g_variant_builder_add_value (builder, _tmp17_);
	_g_variant_unref0 (_tmp17_);
	_tmp18_ = self->priv->settings;
	_tmp19_ = g_variant_builder_end (builder);
	g_variant_ref_sink (_tmp19_);
	_tmp20_ = _tmp19_;
	g_settings_set_value (_tmp18_, "persist-window-geometry", _tmp20_);
	_g_variant_unref0 (_tmp20_);
	_g_variant_builder_unref0 (builder);
}


static gint peek_ui_application_window_get_window_width (PeekUiApplicationWindow* self) {
	gint result = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	w = _tmp0_;
	h = _tmp1_;
	result = w;
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static void peek_ui_application_window_set_close_button_position (PeekUiApplicationWindow* self) {
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_ = NULL;
	GtkSettings* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GtkSettings* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* decoration_layout = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	settings = _tmp1_;
	_tmp3_ = settings;
	g_object_get (_tmp3_, "gtk-decoration-layout", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp2_ = _tmp5_;
	if (_tmp2_ == NULL) {
		gchar* _tmp6_ = NULL;
		_tmp6_ = g_strdup ("");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp6_;
	}
	_tmp7_ = _tmp2_;
	_tmp2_ = NULL;
	decoration_layout = _tmp7_;
	_tmp8_ = decoration_layout;
	g_debug ("application-window.vala:678: Decoration layout: %s", _tmp8_);
	_tmp9_ = decoration_layout;
	_tmp10_ = string_contains (_tmp9_, ":");
	if (_tmp10_) {
		gchar** decoration = NULL;
		const gchar* _tmp11_ = NULL;
		gchar** _tmp12_ = NULL;
		gchar** _tmp13_ = NULL;
		gint decoration_length1 = 0;
		gint _decoration_size_ = 0;
		gchar** _tmp14_ = NULL;
		gint _tmp14__length1 = 0;
		const gchar* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		_tmp11_ = decoration_layout;
		_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, ":", 2);
		decoration = _tmp13_;
		decoration_length1 = _vala_array_length (_tmp12_);
		_decoration_size_ = decoration_length1;
		_tmp14_ = decoration;
		_tmp14__length1 = decoration_length1;
		_tmp15_ = _tmp14_[0];
		_tmp16_ = string_contains (_tmp15_, "close");
		if (_tmp16_) {
			peek_ui_application_window_move_close_button_left (self);
		}
		decoration = (_vala_array_free (decoration, decoration_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (decoration_layout);
	_g_free0 (_tmp2_);
	_g_object_unref0 (settings);
}


static void peek_ui_application_window_move_close_button_left (PeekUiApplicationWindow* self) {
	gchar** decoration = NULL;
	GtkHeaderBar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint decoration_length1 = 0;
	gint _decoration_size_ = 0;
	gboolean _tmp5_ = FALSE;
	gchar** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->headerbar;
	_tmp1_ = gtk_header_bar_get_decoration_layout (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 2);
	decoration = _tmp4_;
	decoration_length1 = _vala_array_length (_tmp3_);
	_decoration_size_ = decoration_length1;
	_tmp6_ = decoration;
	_tmp6__length1 = decoration_length1;
	if (_tmp6__length1 == 2) {
		gchar** _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		const gchar* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		_tmp7_ = decoration;
		_tmp7__length1 = decoration_length1;
		_tmp8_ = _tmp7_[1];
		_tmp9_ = string_contains (_tmp8_, "close");
		_tmp5_ = _tmp9_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GtkHeaderBar* _tmp10_ = NULL;
		gchar** _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar** _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		const gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		_tmp10_ = self->priv->headerbar;
		_tmp11_ = decoration;
		_tmp11__length1 = decoration_length1;
		_tmp12_ = _tmp11_[1];
		_tmp13_ = g_strconcat (_tmp12_, ":", NULL);
		_tmp14_ = _tmp13_;
		_tmp15_ = decoration;
		_tmp15__length1 = decoration_length1;
		_tmp16_ = _tmp15_[0];
		_tmp17_ = g_strconcat (_tmp14_, _tmp16_, NULL);
		_tmp18_ = _tmp17_;
		gtk_header_bar_set_decoration_layout (_tmp10_, _tmp18_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp14_);
	}
	decoration = (_vala_array_free (decoration, decoration_length1, (GDestroyNotify) g_free), NULL);
}


PeekRecordingScreenRecorder* peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self) {
	PeekRecordingScreenRecorder* result;
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_recorder;
	result = _tmp0_;
	return result;
}


void peek_ui_application_window_set_recorder (PeekUiApplicationWindow* self, PeekRecordingScreenRecorder* value) {
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	PeekRecordingScreenRecorder* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_recorder);
	self->priv->_recorder = _tmp1_;
	g_object_notify ((GObject *) self, "recorder");
}


gboolean peek_ui_application_window_get_open_file_manager (PeekUiApplicationWindow* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_open_file_manager;
	result = _tmp0_;
	return result;
}


void peek_ui_application_window_set_open_file_manager (PeekUiApplicationWindow* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_open_file_manager = _tmp0_;
	g_object_notify ((GObject *) self, "open-file-manager");
}


gint peek_ui_application_window_get_size_indicator_delay (PeekUiApplicationWindow* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_size_indicator_delay;
	result = _tmp0_;
	return result;
}


void peek_ui_application_window_set_size_indicator_delay (PeekUiApplicationWindow* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_size_indicator_delay = _tmp0_;
	g_object_notify ((GObject *) self, "size-indicator-delay");
}


gint peek_ui_application_window_get_recording_start_delay (PeekUiApplicationWindow* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_recording_start_delay;
	result = _tmp0_;
	return result;
}


void peek_ui_application_window_set_recording_start_delay (PeekUiApplicationWindow* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_recording_start_delay = _tmp0_;
	g_object_notify ((GObject *) self, "recording-start-delay");
}


const gchar* peek_ui_application_window_get_default_file_name_format (PeekUiApplicationWindow* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_file_name_format;
	result = _tmp0_;
	return result;
}


void peek_ui_application_window_set_default_file_name_format (PeekUiApplicationWindow* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_default_file_name_format);
	self->priv->_default_file_name_format = _tmp1_;
	g_object_notify ((GObject *) self, "default-file-name-format");
}


const gchar* peek_ui_application_window_get_save_folder (PeekUiApplicationWindow* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_save_folder;
	result = _tmp0_;
	return result;
}


void peek_ui_application_window_set_save_folder (PeekUiApplicationWindow* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_save_folder);
	self->priv->_save_folder = _tmp1_;
	g_object_notify ((GObject *) self, "save-folder");
}


static void peek_ui_application_window_class_init (PeekUiApplicationWindowClass * klass) {
	gint PeekUiApplicationWindow_private_offset;
	peek_ui_application_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PeekUiApplicationWindowPrivate));
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*)(GtkWidget*, GdkEventConfigure*)) peek_ui_application_window_real_configure_event;
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*)(GtkWidget*, GdkEventAny*)) peek_ui_application_window_real_delete_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_peek_ui_application_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_peek_ui_application_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = peek_ui_application_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_RECORDER, g_param_spec_object ("recorder", "recorder", "recorder", PEEK_RECORDING_TYPE_SCREEN_RECORDER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER, g_param_spec_boolean ("open-file-manager", "open-file-manager", "open-file-manager", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY, g_param_spec_int ("size-indicator-delay", "size-indicator-delay", "size-indicator-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY, g_param_spec_int ("recording-start-delay", "recording-start-delay", "recording-start-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT, g_param_spec_string ("default-file-name-format", "default-file-name-format", "default-file-name-format", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER, g_param_spec_string ("save-folder", "save-folder", "save-folder", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	PeekUiApplicationWindow_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/uploadedlobster/peek/application-window.ui");
	g_signal_new ("recording_finished", PEEK_UI_TYPE_APPLICATION_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, headerbar));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "recording_view", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, recording_view));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "record_button", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, record_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stop_button", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, stop_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "size_indicator", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, size_indicator));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delay_indicator", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, delay_indicator));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_screen_changed", G_CALLBACK(_peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_draw", G_CALLBACK(_peek_ui_application_window_on_window_draw_gtk_widget_draw));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_draw", G_CALLBACK(_peek_ui_application_window_on_recording_view_draw_gtk_widget_draw));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_size_allocate", G_CALLBACK(_peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_record_button_clicked", G_CALLBACK(_peek_ui_application_window_on_record_button_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_stop_button_clicked", G_CALLBACK(_peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked));
}


static void peek_ui_application_window_instance_init (PeekUiApplicationWindow * self) {
	self->priv = PEEK_UI_APPLICATION_WINDOW_GET_PRIVATE (self);
	self->priv->size_indicator_timeout = (guint) 0;
	self->priv->delay_indicator_timeout = (guint) 0;
	self->priv->is_recording = FALSE;
	self->priv->is_postprocessing = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void peek_ui_application_window_finalize (GObject* obj) {
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
	_g_object_unref0 (self->priv->_recorder);
	_g_free0 (self->priv->_default_file_name_format);
	_g_free0 (self->priv->_save_folder);
	_g_object_unref0 (self->priv->headerbar);
	_g_object_unref0 (self->priv->recording_view);
	_g_object_unref0 (self->priv->record_button);
	_g_object_unref0 (self->priv->stop_button);
	_g_object_unref0 (self->priv->size_indicator);
	_g_object_unref0 (self->priv->delay_indicator);
	_g_object_unref0 (self->priv->in_file);
	_g_object_unref0 (self->priv->out_file);
	peek_recording_recording_area_destroy (&self->priv->active_recording_area);
	_g_free0 (self->priv->stop_button_label);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (peek_ui_application_window_parent_class)->finalize (obj);
}


GType peek_ui_application_window_get_type (void) {
	static volatile gsize peek_ui_application_window_type_id__volatile = 0;
	if (g_once_init_enter (&peek_ui_application_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PeekUiApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_ui_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekUiApplicationWindow), 0, (GInstanceInitFunc) peek_ui_application_window_instance_init, NULL };
		GType peek_ui_application_window_type_id;
		peek_ui_application_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PeekUiApplicationWindow", &g_define_type_info, 0);
		g_once_init_leave (&peek_ui_application_window_type_id__volatile, peek_ui_application_window_type_id);
	}
	return peek_ui_application_window_type_id__volatile;
}


static void _vala_peek_ui_application_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
	switch (property_id) {
		case PEEK_UI_APPLICATION_WINDOW_RECORDER:
		g_value_set_object (value, peek_ui_application_window_get_recorder (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER:
		g_value_set_boolean (value, peek_ui_application_window_get_open_file_manager (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY:
		g_value_set_int (value, peek_ui_application_window_get_size_indicator_delay (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY:
		g_value_set_int (value, peek_ui_application_window_get_recording_start_delay (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT:
		g_value_set_string (value, peek_ui_application_window_get_default_file_name_format (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER:
		g_value_set_string (value, peek_ui_application_window_get_save_folder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_peek_ui_application_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
	switch (property_id) {
		case PEEK_UI_APPLICATION_WINDOW_RECORDER:
		peek_ui_application_window_set_recorder (self, g_value_get_object (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER:
		peek_ui_application_window_set_open_file_manager (self, g_value_get_boolean (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY:
		peek_ui_application_window_set_size_indicator_delay (self, g_value_get_int (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY:
		peek_ui_application_window_set_recording_start_delay (self, g_value_get_int (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT:
		peek_ui_application_window_set_default_file_name_format (self, g_value_get_string (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER:
		peek_ui_application_window_set_save_folder (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



